local bagTotalSlots = {}

local bagFreeSlots = {}

local BagStringNames = {BagEnds_BagString0, BagEnds_BagString1, BagEnds_BagString2, BagEnds_BagString3, BagEnds_BagString4}

local BagOutlineNames = {BagEnds_BagOutline0, BagEnds_BagOutline1, BagEnds_BagOutline2, BagEnds_BagOutline3, BagEnds_BagOutline4}

local function GetBagColor(i)
   local r,g,b
   
	if bagFreeSlots[i] == 0 then 
		r, g, b = 1.0, 0.0, 0.0
   	elseif bagFreeSlots[i]/bagTotalSlots[i] <= 0.25 then 
		r, g, b = 1.0, 0.5, 0.0

   	elseif bagFreeSlots[i]/bagTotalSlots[i] < 1 then 
		r, g, b = 1.0, 1.0, 0.0
	else 
		r, g, b = 0.0, 1.0, 0.0
	end

	return r, g, b
end

local function GetBagSlotString()
	local tempString
	for i = 1,5 do
		if (BagEndsConfig.occupied) then
			tempString = bagTotalSlots[i] - bagFreeSlots[i]
		else
			tempString = bagFreeSlots[i]
		end
		if (BagEndsConfig.showTotal) then
			tempString = tempString .. "/" .. bagTotalSlots[i]
		end
		BagStringNames[i]:SetText(tempString)
	end
end

local function SetFontColor()
	if (BagEndsConfig.colorText) then
		for i = 1,5 do
			BagStringNames[i]:SetTextColor(GetBagColor(i))
		end
	else
		for i = 1,5 do
			BagStringNames[i]:SetTextColor(1.0, 1.0, 1.0)
		end
	end
end

local function DrawString()
	if (BagEndsConfig.showText) then
		for i = 1,5 do
			BagStringNames[i]:Show()
		end
		GetBagSlotString()
		SetFontColor()
	else
		for i = 1,5 do
			BagStringNames[i]:Hide()
		end
	end
end

local function DrawOutline()
	if (BagEndsConfig.outline) then
		for i = 1,5 do
			BagOutlineNames[i]:SetVertexColor(GetBagColor(i))
			BagOutlineNames[i]:Show()
		end
	else
		for i = 1,5 do
			BagOutlineNames[i]:Hide()
		end
	end
end


function BagEndsUpdate()
   
	for i = 1,5 do
		bagTotalSlots[i] = GetContainerNumSlots(i-1)  
		bagFreeSlots[i] = GetContainerNumFreeSlots(i-1)
	end

	DrawString()
	DrawOutline()
end